/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified for MAG(internal) 1998 Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"PICSLICE.H"

extern int	loadMAGfile( picsliceinfo* );
extern int	drawMAG( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );
extern void	psierr( char*, int );


void
MagResize( gp, psi )
GVIEW	*gp;
picsliceinfo	psi;
{
	unsigned short	*str= gp->buf, *ptr= gp->buf;
	int	y;
	for( y= 0; y< psi.height; y++, ptr+= (psi.realwidth-psi.width) ){
		int	x;
		for( x= 0 ; x< psi.width; x++ )
			*str++= *ptr++;
	}
	SETBLOCK( gp, ((char*)gp->buf) - (char*)gp + psi.width*psi.height );
	gp->h= psi.width;
}

GVIEW *
GV_Load_Mag( fname )
char	*fname;
{
	char	format[]= "MAG";
	picsliceinfo	psi;
	GVIEW	*gp;
	int	ret;

	if( (psi.filehandle= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}
	if( ( ret= loadMAGfile( &psi ) ) != PICSLICE_NORMAL ){
		psierr( format, ret );
		return	NULL;
	}
	if( !(gp= GV_Alloc( psi.realwidth, psi.height, (psi.color + 1) *4,
						fname, NULL, 0 )) ){
		EndOfDraw( &psi );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	(unsigned short*)psi.chainbuf= gp->buf;
	if( ( ret= drawMAG( &psi ) ) != PICSLICE_TERMINATE ){
		psierr( format, ret );
		MFREE( gp );
		return	NULL;
	}else {
		unsigned short	*str= gp->palet,
				*ptr= psi.colortable;
		int	i, max= psi.color? 256:16;
		for( i= 0 ; i< max ; i++ ){
			*str++= *ptr++;
		}
	}
	if( psi.width != psi.realwidth )	MagResize( gp, psi );
	return gp;
}
