/*	Copyright 1992 H.Ogasawara (COR.)	*/
/*	modified 1998 by Shinichi Honma	*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"
#include	"PICSLICE.H"

extern int	loadPICfile( picsliceinfo*, unsigned char* );
extern int	drawPIC( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );
extern void	GV_Err2( char*, char* );

void
psierr( ext, type )
char	*ext;
int	type;
{
	char *msg;
	switch( type ){
	case PICSLICE_EFORMAT:
		msg= "tH[}bgႢ܂";
		break;
	case PICSLICE_EREAD:
		msg= "[hG[";
		break;
	case PICSLICE_EOVERFLOW:
		msg= "I[o[t[܂";
		break;
	case PICSLICE_NOMEMORY:
		msg= "܂";
		break;
	case PICSLICE_EOPEN:
		msg= "I[vł܂";
		break;
	default:
		msg= "̃G[";
	}
	GV_Err2( ext, msg );
}

GVIEW *
GV_Load_Pic( fname )
char	*fname;
{
	char	format[]= "PIC";
	unsigned char	com[256];
	picsliceinfo	psi;
	GVIEW	*gp;
	int	ret;

	if( (psi.filehandle= OPEN( fname, 0 )) < 0 ){
		psierr( format, PICSLICE_EOPEN );
		return	NULL;
	}
	if( (ret= loadPICfile( &psi, com ) )!= PICSLICE_NORMAL ){
		psierr( format, ret );
		return	NULL;
	}
	if( !(gp= GV_Alloc( psi.width, psi.height, WindowAttrGraphic65536,
							fname, com+3, 0 )) ){
		EndOfDraw( &psi );
		psierr( format, PICSLICE_NOMEMORY );
		return	NULL;
	}
	(unsigned short*)psi.chainbuf= gp->buf;
	if( ( ret= drawPIC( &psi ) ) != PICSLICE_TERMINATE ){
		psierr( format, ret );
		MFREE( gp );
		return	NULL;
	}
	return gp;
}
